import { SlotInfo, StatusInfo } from "./definitions/adventureland";
import { Attribute, ConditionName, DamageType, GData2, GMonster, MapName, MonsterName, SkillName } from "./definitions/adventureland-data";
import { ActionData, MonsterData } from "./definitions/adventureland-server";
import { Character } from "./Character";
import { Player } from "./Player";
export declare class Entity implements MonsterData, Partial<GMonster> {
    protected G: GData2;
    abs?: false;
    angle: number;
    cid: number;
    going_x: number;
    going_y: number;
    map: MapName;
    move_num: number;
    moving: boolean;
    x: number;
    y: number;
    target: string;
    abilities: {
        [T in SkillName]?: any;
    };
    charge: number;
    cooperative: boolean;
    damage_type: DamageType;
    attack: number;
    frequency: number;
    hp: number;
    mp: number;
    range: number;
    speed: number;
    apiercing: number;
    armor: number;
    avoidance: number;
    blast: number;
    breaks: number;
    crit: number;
    critdamage: number;
    evasion: number;
    lifesteal: number;
    mcourage: number;
    reflection: number;
    resistance: number;
    rpiercing: number;
    readonly aggro: number;
    readonly name: string;
    readonly rage: number;
    readonly respawn: number;
    readonly skin: string;
    readonly "1hp" = false;
    readonly aa = 0;
    readonly achievements: [number, "stat", Attribute, number][];
    readonly announce?: string;
    readonly article?: string;
    readonly balance?: string;
    readonly cute = false;
    readonly difficulty?: number;
    readonly escapist = false;
    readonly explanation?: string;
    readonly global = false;
    readonly goldsteal = 0;
    readonly hit?: string;
    readonly humanoid = false;
    readonly immune = false;
    readonly lucrativeness?: number;
    readonly operator = false;
    readonly orientation?: number;
    readonly passive = false;
    readonly pet?: {
        aggression: [number, number];
        brightness: number;
        chatter: [number, number];
        courage: [number, number];
        exponential: boolean;
        level: {
            [T in Attribute]?: number;
        };
        obedience: [number, number];
        passion: [number, number];
        xp: number;
    };
    readonly poisonous = false;
    readonly prefix = "";
    readonly projectile?: string;
    readonly rbuff: ConditionName;
    readonly roam = false;
    readonly size?: number;
    readonly slots?: Partial<SlotInfo>;
    readonly spawns?: [number, MonsterName][];
    readonly special = false;
    readonly stationary = false;
    readonly supporter = false;
    readonly trap = false;
    readonly unlist = false;
    id: string;
    level: number;
    max_hp: number;
    max_mp: number;
    s: StatusInfo;
    type: MonsterName;
    xp: number;
    constructor(data: MonsterData, map: MapName, G: GData2);
    updateData(data: MonsterData): void;
    calculateDamageRange(defender: Character | Entity | Player): [number, number];
    couldDieToProjectiles(projectiles: Map<string, ActionData>, players: Map<string, Player>, entities: Map<string, Entity>): boolean;
    couldGiveCreditForKill(player: Character): boolean;
    isAttackingPartyMember(player: Character): boolean;
    isAttackingUs(player: Character): boolean;
    isTauntable(by: Character): boolean;
    willBurnToDeath(): boolean;
    willDieToProjectiles(projectiles: Map<string, ActionData>, players: Map<string, Player>, entities: Map<string, Entity>): boolean;
}
