"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Paladin = void 0;
const Constants_1 = require("./Constants");
const PingCompensatedCharacter_1 = require("./PingCompensatedCharacter");
class Paladin extends PingCompensatedCharacter_1.PingCompensatedCharacter {
    manaShieldOff() {
        if (!this.ready)
            return Promise.reject("We aren't ready yet [manaShieldOff].");
        if (!this.s.mshield)
            return Promise.resolve();
        const shieldCheck = new Promise((resolve, reject) => {
            const successCheck = (data) => {
                if (!data.s || !data.s.mshield) {
                    this.socket.removeListener("player", successCheck);
                    resolve();
                }
            };
            setTimeout(() => {
                this.socket.removeListener("player", successCheck);
                reject(`manaShieldOff timeout (${Constants_1.Constants.TIMEOUT}ms)`);
            }, Constants_1.Constants.TIMEOUT);
        });
        this.socket.emit("skill", { name: "mshield" });
        return shieldCheck;
    }
    manaShieldOn() {
        if (!this.ready)
            return Promise.reject("We aren't ready yet [manaShieldOn].");
        if (this.s.mshield)
            return Promise.resolve();
        const shieldCheck = new Promise((resolve, reject) => {
            const successCheck = (data) => {
                if (data.s?.mshield) {
                    this.socket.removeListener("player", successCheck);
                    resolve();
                }
            };
            setTimeout(() => {
                this.socket.removeListener("player", successCheck);
                reject(`manaShieldOn timeout (${Constants_1.Constants.TIMEOUT}ms)`);
            }, Constants_1.Constants.TIMEOUT);
        });
        this.socket.emit("skill", { name: "mshield" });
        return shieldCheck;
    }
    selfHeal() {
        if (!this.ready)
            return Promise.reject("We aren't ready yet [selfHeal].");
        const healed = new Promise((resolve, reject) => {
            const cooldownCheck = (data) => {
                if (/skill_timeout\s*\(\s*['"]selfheal['"]\s*,?\s*(\d+\.?\d+?)?\s*\)/.test(data.code)) {
                    this.socket.removeListener("eval", cooldownCheck);
                    resolve();
                }
            };
            setTimeout(() => {
                this.socket.removeListener("eval", cooldownCheck);
                reject(`selfheal timeout (${Constants_1.Constants.TIMEOUT}ms)`);
            }, Constants_1.Constants.TIMEOUT);
            this.socket.on("eval", cooldownCheck);
        });
        this.socket.emit("skill", { name: "selfheal" });
        return healed;
    }
}
exports.Paladin = Paladin;
//# sourceMappingURL=Paladin.js.map